﻿;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;			
;|																															|;	
;| Title:				UB2D - 003_GUI																	|;
;| Copyright: 	UnionBytes																			|;
;|																															|;
;| Date:				07.11.2018																			|;
;|																															|;
;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;


;- Engine
XIncludeFile "Includes\UB2D.pbi" 
If Not InitUnionBytes2DEngine(#UB2D_ENGINE_DEBUG)
	Debug "UB2D initialization failed!"
	End
EndIf

UB2D_OpenScreen(1280, 720, 32, "Union Bytes 2D Engine - GUI", #PB_Window_ScreenCentered|#PB_Window_SystemMenu, #False)
UB2D_ScreenClearColor($FF9C9C9C)


;- Enumerations
Enumeration
	#Window
	#Gadget_Button
	#Gadget_DisabledButton
	#Gadget_ListView
	#Gadget_StringInput
	#Gadget_CheckBox
	#Gadget_Progessbar
	#Gadget_Slider
	#Gadget_Spin
EndEnumeration


;- Variables
Define I.i


;- GUI
; Create a window with gadgets
If UB2D_CreateWindow(#Window, 100, 100, 600, 310, "Window")
	; Create Gadgets with a constant (number) or #UB2D_ANY
	UB2D_TextGadget(#UB2D_ANY, 20, 60, "Windows are container for gadgets. Windows can be moved.")
	UB2D_ButtonGadget(#Gadget_Button, 20, 100, 120, 30, "Just a button")
	UB2D_ButtonGadget(#Gadget_DisabledButton, 160, 100, 120, 30, "disabled")
	
	UB2D_StringGadget(#Gadget_StringInput, 20, 140, 260, 30, "I'm an string input gadget")
	
	UB2D_CheckBoxGadget(#Gadget_CheckBox, 20, 180, "Check box gadget")
	
	UB2D_TextGadget(#UB2D_ANY, 20, 220, "Progressbar: ")
	UB2D_ProgressbarGadget(#Gadget_Progessbar, 120, 220, 160, 100, 0)
	
	UB2D_TextGadget(#UB2D_ANY, 20, 260, "Slider: ")
	UB2D_SliderGadget(#Gadget_Slider, 120, 260, 160, 10, 0)
	
	UB2D_TextGadget(#UB2D_ANY, 300, 260, "Spin gadget: ")
	UB2D_SpinGadget(#Gadget_Spin, 400, 260, 100, 10, -10)
	
	; Currently it's only possible to scroll the ListViewGadget with the mouse wheel.
	UB2D_ListViewGadget(#Gadget_ListView, 300, 100, 280, 140) 
	For I = 0 To 8
		UB2D_AddGadgetItem(#Gadget_ListView, -1, "ListView entry "+Str(I))
	Next
	
EndIf

; Disbale one gadget
UB2D_DisableGadget(#Gadget_DisabledButton)

;- Main Loop
Repeat
	
	; Normal pure basic window event handling.
	Repeat
		Select UB2D_WindowEvent()
			Case #PB_Event_CloseWindow
				Break 2
			Case #PB_Event_None
				Break
		EndSelect 
	ForEver
	
	; UB2D GUI event handling.
	Select UB2D_Event()
		Case #UB2D_EVENT_GADGET
			Select UB2D_EventGadget()
				Case #Gadget_Button
					UB2D_Debug("Just a button")
				Case #Gadget_CheckBox
					; Debug the state of the ckeck box
					UB2D_Debug("Checkbox: "+UB2D_GetGadgetState(#Gadget_CheckBox))
				Case #Gadget_Slider
					; Debug the value of the ckeck box
					UB2D_Debug("Slider value: "+UB2D_GetGadgetValue(#Gadget_Slider))
				Case #Gadget_ListView
					UB2D_Debug("ListView item: "+UB2D_GetGadgetText(#Gadget_ListView))
			EndSelect
	EndSelect
	
	; Update of the control functions.
	UB2D_ExamineMouse()
	UB2D_ExamineKeyboard()
	
	; SetUp of the render target. In this case the final frame buffer.
	UB2D_BindFrameBuffer(#UB2D_FRAMEBUFFER_FINAL, #True, #True)
	
	; Set the value of a gadget (for example the progressbar)
	UB2D_SetGadgetValue(#Gadget_Progessbar, Mod(ElapsedMilliseconds()/10,100))
	
	; Display of all GUI elements.
	UB2D_DisplayGUI()
	
	; Flip the buffers and draw it on the window \ screen.
	UB2D_FlipBuffers()
	
	; F12 makes a screenshot
	If UB2D_KeyboardReleased(#UB2D_KEY_F12)
		UB2D_ScreenShot("003_GUI.jpg")
	EndIf
	
ForEver

; Free the engine and all its resources.
UB2D_Free()
End

; IDE Options = PureBasic 5.62 (Windows - x64)
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 770
; EnableBuildCount = 0