﻿;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;			
;|																															|;	
;| Title:				UB2D - 005_Shader																|;
;| Copyright: 	UnionBytes																			|;
;|																															|;
;| Date:				07.11.2018																			|;
;|																															|;
;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;


;- Engine
XIncludeFile "Includes\UB2D.pbi" 
If Not InitUnionBytes2DEngine(#UB2D_ENGINE_DEBUG)
	Debug "UB2D initialization failed!"
	End
EndIf

UB2D_OpenScreen(1280, 720, 32, "Union Bytes 2D Engine - Shader", #PB_Window_ScreenCentered|#PB_Window_SystemMenu, #False)


;- Variables
Global iShaderUniformIndex.i


;- Shader
; Laoad the shader
UB2D_LoadShader(0, #UB2D_SHADER_SPR, "Data\Shader\SPR_Green.vs", "Data\Shader\SPR_Green.fs", "SPR_Green")
; Get the uniform index
iShaderUniformIndex = UB2D_ShaderUniformIndex(0, "fTime")


;- Textures
UB2D_LoadTexture(0, "Data\Sprites\UB2D.jpg")


;- Materials
; Creating of a material, with the default sprite shader and the texture 0.
UB2D_CreateMaterial(0, UB2D_DefaultShaderID(#UB2D_SHADER_SPR_DEFAULT), 0)
; Creating the material, with the new shader 0 and the the texture 0.
UB2D_CreateMaterial(1, 0, 0)


;- Sprites
; Creating the sprites, with the material 0 and a origin in the middle and resize it.
UB2D_CreateSprite(0, 0, 0.5, 0.5)
UB2D_ZoomSprite(0, 512, 512)

UB2D_CreateSprite(1, 1, 0.5, 0.5)
UB2D_ZoomSprite(1, 512, 512)


;- Main Loop
Repeat
	
	; Normal pure basic window event handling.
	Repeat
		Select UB2D_WindowEvent()
			Case #PB_Event_CloseWindow
				Break 2
			Case #PB_Event_None
				Break
		EndSelect 
	ForEver
	
	; Update of the control functions.
	UB2D_ExamineKeyboard()
	
	; SetUp of the render target. In this case the final frame buffer.
	UB2D_BindFrameBuffer(#UB2D_FRAMEBUFFER_FINAL, #True, #True)
		
	; Draw the sprite sprites on the screen.
	UB2D_DisplaySprite(0, UB2D_ScreenWidth()*0.5-280, UB2D_ScreenHeight()*0.5)
	
	; Update the shader uniform to get the animation.
	UB2D_SetShaderUniformFloat(0, iShaderUniformIndex, UB2D_Time()*5)
	UB2D_DisplaySprite(1, UB2D_ScreenWidth()*0.5+280, UB2D_ScreenHeight()*0.5)
	
	; Flip the buffers and draw it on the window.
	UB2D_FlipBuffers()
	
	; F12 makes a screenshot
	If UB2D_KeyboardReleased(#UB2D_KEY_F12)
		UB2D_ScreenShot("005_Shader.jpg")
	EndIf
	
ForEver

; Free the engine and all its resources.
UB2D_Free()
End

; IDE Options = PureBasic 5.62 (Windows - x64)
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 775
; EnableBuildCount = 0