﻿;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;			
;|																															|;	
;| Title:				UB2D - 006_Object																|;
;| Copyright: 	UnionBytes																			|;
;|																															|;
;| Date:				07.11.2018																			|;
;|																															|;
;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;


;- Engine
XIncludeFile "Includes\UB2D.pbi" 
If Not InitUnionBytes2DEngine(#UB2D_ENGINE_DEBUG)
	Debug "UB2D initialization failed!"
	End
EndIf

UB2D_OpenScreen(1280, 720, 32, "Union Bytes 2D Engine - Objects", #PB_Window_ScreenCentered|#PB_Window_SystemMenu, #False)


;- Textures
; Loading the texture for our object.
UB2D_LoadTexture(0, "Data\Textures\UB2D_B.png")	; Base color (albedo map)
UB2D_LoadTexture(1, "Data\Textures\UB2D_N.png") ; Normal map
UB2D_LoadTexture(2, "Data\Textures\UB2D_REM.png") ; REM map (Red = Roughness, Green = Emission, Blue = Metallic)


;- Materials
; Creating of a material, with the default object PBR shader!
UB2D_CreateMaterial(0, UB2D_DefaultShaderID(#UB2D_SHADER_OBJ_PBR), 0)
UB2D_SetMaterialTexture(0, 1, 1) ; Set the normal map to index 1
UB2D_SetMaterialTexture(0, 2, 2) ; Set the rme map to index 2
UB2D_SetMaterialRoughness(0, 1.0) ; Set the roughness map multiplier
UB2D_SetMaterialMetallic(0, 1.0) ; Set the metallic map multiplier
UB2D_SetMaterialEmission(0, 0.0) ; Set the emission map multiplier
UB2D_SetMaterialSpecular(0, 0.2) ; Scale the specular amount


;- Objects
; Creating the objects, with the material 0
UB2D_CreateObject(0, 0, 0.5, 0.5)
; Add a objects instance to the object 0
UB2D_AddObjectInstance(0, 0, 0.0, 0.0, 0.0)


;- Main Loop
Repeat
	
	; Normal pure basic window event handling.
	Repeat
		Select UB2D_WindowEvent()
			Case #PB_Event_CloseWindow
				Break 2
			Case #PB_Event_None
				Break
		EndSelect 
	ForEver
	
	; Update of the control functions.
	UB2D_ExamineKeyboard()
	
	; Rotate the mesh instance
	UB2D_RotateObjectInstance(0, 15.0*UB2D_TimeFactor())
	
	; We have to replace now the funktion UB2D_BindFrameBuffer(#UB2D_FRAMEBUFFER_FINAL, #True, #True)
	; With the following one. After the scene is rendered, the final framebuffer will be set automatically
	UB2D_RenderScene()
	
	; Flip the buffers and draw it on the window.
	UB2D_FlipBuffers()
	
	; F12 makes a screenshot
	If UB2D_KeyboardReleased(#UB2D_KEY_F12)
		UB2D_ScreenShot("006_Objects.jpg")
	EndIf
	
ForEver

; Free the engine and all its resources.
UB2D_Free()
End

; IDE Options = PureBasic 5.62 (Windows - x64)
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 831
; EnableBuildCount = 0