﻿;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;			
;|																															|;	
;| Title:				UB2D - 010_Materials														|;
;| Copyright: 	UnionBytes																			|;
;|																															|;
;| Date:				07.11.2018																			|;
;|																															|;
;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;


;- Engine
XIncludeFile "Includes\UB2D.pbi" 
If Not InitUnionBytes2DEngine(#UB2D_ENGINE_DEBUG)
	Debug "UB2D initialization failed!"
	End
EndIf

UB2D_OpenScreen(1024, 1024, 32, "Union Bytes 2D Engine - Materials", #PB_Window_ScreenCentered|#PB_Window_SystemMenu, #False)


;- World light settings
; Volumetric light is turned on by default. 
; Turn off the volumetric light.
UB2D_SetVolumetricLightState(#False)

; Reducing of the direct light and the ambientlight to see the point lights effects better
UB2D_SetDirectLightIntensity(0.2)
UB2D_SetAmbientLightColor($FFFFFFFF)


;- Variables
Global X.i, Y.i
Global I.i


;- Textures
; Loading the texture for our objects.
UB2D_LoadTexture(0, "Data\Textures\Ball_B.png")	; Base color (albedo map)
UB2D_LoadTexture(1, "Data\Textures\Ball_N.png") ; Normal map
UB2D_LoadTexture(2, "Data\Textures\Ball_REM.png") ; REM map (Red = Roughness, Green = Emission, Blue = Metallic)


;- Materials
For Y = 0 To 10
	For X = 0 To 10
		I = Y*11+X
		
		UB2D_CreateMaterial(I, UB2D_DefaultShaderID(#UB2D_SHADER_OBJ_PBR), 0)
		UB2D_SetMaterialTexture(I, 1, 1)
		UB2D_SetMaterialTexture(I, 2, 2)
		UB2D_SetMaterialRoughness(I, 1.0-(X*0.1))
		UB2D_SetMaterialMetallic(I, Y*0.1)
		UB2D_SetMaterialEmission(I, 0.0)
		UB2D_SetMaterialSpecular(I, 1.0)
		
		UB2D_CreateObject(I, I, 0.5, 0.5)
		UB2D_ResizeObject(I, 92, 92)
		UB2D_AddObjectInstance(I, I, X*92-UB2D_ScreenWidth()*0.5+48,  Y*92-UB2D_ScreenHeight()*0.5+48, 0.0)
	Next
Next


;- Main Loop
Repeat
	
	; Normal pure basic window event handling.
	Repeat
		Select UB2D_WindowEvent()
			Case #PB_Event_CloseWindow
				Break 2
			Case #PB_Event_None
				Break
		EndSelect 
	ForEver
	
	; Mouse and keyboard functions.
	UB2D_ExamineKeyboard()
	
; 	; Rotate the material balls
; 	For Y = 0 To 10
; 		For X = 0 To 10
; 			I = Y*11+X
; 			UB2D_RotateObjectInstance(I, 5.0 * UB2D_TimeFactor())	
; 		Next
; 	Next
	
	; We have to replace now the funktion UB2D_BindFrameBuffer(#UB2D_FRAMEBUFFER_FINAL, #True, #True)
	; With the following one. After the scene is rendered, the final framebuffer will be set automatically
	UB2D_RenderScene()
	
	; Flip the buffers and draw it on the window.
	UB2D_FlipBuffers()
	
	; F12 makes a screenshot
	If UB2D_KeyboardReleased(#UB2D_KEY_F12)
		UB2D_ScreenShot("010_Materials.jpg")
	EndIf
	
ForEver

; Free the engine and all its resources.
UB2D_Free()
End

; IDE Options = PureBasic 5.62 (Windows - x64)
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 947
; EnableBuildCount = 0