﻿;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;			
;|																															|;	
;| Title:				UB2D - 012_Drawing															|;
;| Copyright: 	UnionBytes																			|;
;|																															|;
;| Date:				31.10.2018																			|;
;|																															|;
;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||;


;- Engine
XIncludeFile "Includes\UB2D.pbi" 
If Not InitUnionBytes2DEngine(#UB2D_ENGINE_DEBUG)
	Debug "UB2D initialization failed!"
	End
EndIf

UB2D_OpenScreen(1280, 720, 32, "Union Bytes 2D Engine - Drawing", #PB_Window_ScreenCentered|#PB_Window_SystemMenu, #False)


;- Vatiables
Global fRotation.f

;- Main Loop
Repeat
	
	; Normal pure basic window event handling.
	Repeat
		Select UB2D_WindowEvent()
			Case #PB_Event_CloseWindow
				Break 2
			Case #PB_Event_None
				Break
		EndSelect 
	ForEver
	
	; Update of the control functions.
	UB2D_ExamineKeyboard()
	
	; SetUp of of the render target. In this case the final frame buffer.
	UB2D_BindFrameBuffer(#UB2D_FRAMEBUFFER_FINAL, #True, #True)
		
	; Set the drawing transformation and let it rotate
	UB2D_MoveDrawingTransformation(0.0, 0.0, 0.0)
	fRotation + 15.0*UB2D_TimeFactor()
	UB2D_SetDrawingTransformationRotation(-30.0, 0.0, 0.0)
	UB2D_RotateDrawingTransformation(0.0, fRotation, 0.0)
	
	; Fills the drawing buffer
	UB2D_Draw2DBox(0, -200, 400, 200, 0, $FFFFFFFF)
	UB2D_Draw3DBox(100, 100, 100, 200, 200, 200, $FFFFFF00)
	UB2D_Draw3DBox(140, 140, 200, 180, 180, 240, $FF3AD5FF)
	
	
	; Reset the transformation
	UB2D_ResetDrawingTransformationMatrix()
	
	; Fills the drawing buffer again
	UB2D_Draw2DBox(-600, -200, -300, 0, -100, $FFFFFFFF)
	UB2D_Draw2DCircle(-450, -100, 50, -100, $FF2100FF)
	
	; Draw all data in the buffer
	UB2D_DisplayDrawingBuffer()
	
	; Flip the buffers and draw it on the window \ screen.
	UB2D_FlipBuffers()
	
	; F12 makes a screenshot
	If UB2D_KeyboardReleased(#UB2D_KEY_F12)
		UB2D_ScreenShot("012_Drawing.jpg")
	EndIf
	
ForEver

; Free the engine and all its resources.
UB2D_Free()
End

; IDE Options = PureBasic 5.62 (Windows - x64)
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 776
; EnableBuildCount = 0